Index: dnspython-1.12.0/dns/rdtypes/ANY/NSEC3PARAM.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/NSEC3PARAM.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/NSEC3PARAM.py
@@ -13,13 +13,18 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-import cStringIO
+from io import BytesIO
 import struct
+import binascii
 
 import dns.exception
 import dns.rdata
+from dns._compat import text_type
+from dns._compat import xcmp
+
 
 class NSEC3PARAM(dns.rdata.Rdata):
+
     """NSEC3PARAM record
 
     @ivar algorithm: the hash algorithm number
@@ -38,16 +43,21 @@ class NSEC3PARAM(dns.rdata.Rdata):
         self.algorithm = algorithm
         self.flags = flags
         self.iterations = iterations
-        self.salt = salt
+        if isinstance(salt, text_type):
+            self.salt = salt.encode()
+        else:
+            self.salt = salt
 
     def to_text(self, origin=None, relativize=True, **kw):
-        if self.salt == '':
+        if self.salt == b'':
             salt = '-'
         else:
-            salt = self.salt.encode('hex-codec')
-        return '%u %u %u %s' % (self.algorithm, self.flags, self.iterations, salt)
+            salt = binascii.hexlify(self.salt).decode()
+        return '%u %u %u %s' % (self.algorithm, self.flags, self.iterations,
+                                salt)
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         algorithm = tok.get_uint8()
         flags = tok.get_uint8()
         iterations = tok.get_uint16()
@@ -55,21 +65,21 @@ class NSEC3PARAM(dns.rdata.Rdata):
         if salt == '-':
             salt = ''
         else:
-            salt = salt.decode('hex-codec')
+            salt = binascii.unhexlify(salt.encode())
         tok.get_eol()
         return cls(rdclass, rdtype, algorithm, flags, iterations, salt)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         l = len(self.salt)
         file.write(struct.pack("!BBHB", self.algorithm, self.flags,
                                self.iterations, l))
         file.write(self.salt)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
-        (algorithm, flags, iterations, slen) = struct.unpack('!BBHB',
-                                                             wire[current : current + 5])
+        (algorithm, flags, iterations, slen) = \
+             struct.unpack('!BBHB',
+                           wire[current: current + 5])
         current += 5
         rdlen -= 5
         salt = wire[current : current + slen].unwrap()
@@ -79,11 +89,9 @@ class NSEC3PARAM(dns.rdata.Rdata):
             raise dns.exception.FormError
         return cls(rdclass, rdtype, algorithm, flags, iterations, salt)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
-        b1 = cStringIO.StringIO()
+        b1 = BytesIO()
         self.to_wire(b1)
-        b2 = cStringIO.StringIO()
+        b2 = BytesIO()
         other.to_wire(b2)
-        return cmp(b1.getvalue(), b2.getvalue())
+        return xcmp(b1.getvalue(), b2.getvalue())
Index: dnspython-1.12.0/dns/rdtypes/ANY/RP.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/RP.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/RP.py
@@ -16,8 +16,11 @@
 import dns.exception
 import dns.rdata
 import dns.name
+from dns._compat import xcmp
+
 
 class RP(dns.rdata.Rdata):
+
     """RP record
 
     @ivar mbox: The responsible person's mailbox
@@ -39,7 +42,8 @@ class RP(dns.rdata.Rdata):
         txt = self.txt.choose_relativity(origin, relativize)
         return "%s %s" % (str(mbox), str(txt))
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         mbox = tok.get_name()
         txt = tok.get_name()
         mbox = mbox.choose_relativity(origin, relativize)
@@ -47,17 +51,16 @@ class RP(dns.rdata.Rdata):
         tok.get_eol()
         return cls(rdclass, rdtype, mbox, txt)
 
-    from_text = classmethod(from_text)
-
-    def to_wire(self, file, compress = None, origin = None):
+    def to_wire(self, file, compress=None, origin=None):
         self.mbox.to_wire(file, None, origin)
         self.txt.to_wire(file, None, origin)
 
-    def to_digestable(self, origin = None):
+    def to_digestable(self, origin=None):
         return self.mbox.to_digestable(origin) + \
             self.txt.to_digestable(origin)
 
-    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
+    @classmethod
+    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin=None):
         (mbox, cused) = dns.name.from_wire(wire[: current + rdlen],
                                            current)
         current += cused
@@ -68,19 +71,17 @@ class RP(dns.rdata.Rdata):
                                           current)
         if cused != rdlen:
             raise dns.exception.FormError
-        if not origin is None:
+        if origin is not None:
             mbox = mbox.relativize(origin)
             txt = txt.relativize(origin)
         return cls(rdclass, rdtype, mbox, txt)
 
-    from_wire = classmethod(from_wire)
-
-    def choose_relativity(self, origin = None, relativize = True):
+    def choose_relativity(self, origin=None, relativize=True):
         self.mbox = self.mbox.choose_relativity(origin, relativize)
         self.txt = self.txt.choose_relativity(origin, relativize)
 
     def _cmp(self, other):
-        v = cmp(self.mbox, other.mbox)
+        v = xcmp(self.mbox, other.mbox)
         if v == 0:
-            v = cmp(self.txt, other.txt)
+            v = xcmp(self.txt, other.txt)
         return v
Index: dnspython-1.12.0/dns/rdtypes/ANY/RRSIG.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/RRSIG.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/RRSIG.py
@@ -13,6 +13,7 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
+import base64
 import calendar
 import struct
 import time
@@ -38,10 +39,13 @@ def sigtime_to_posixtime(what):
     return calendar.timegm((year, month, day, hour, minute, second,
                             0, 0, 0))
 
+
 def posixtime_to_sigtime(what):
     return time.strftime('%Y%m%d%H%M%S', time.gmtime(what))
 
+
 class RRSIG(dns.rdata.Rdata):
+
     """RRSIG record
 
     @ivar type_covered: the rdata type this signature covers
@@ -95,9 +99,10 @@ class RRSIG(dns.rdata.Rdata):
             self.key_tag,
             self.signer.choose_relativity(origin, relativize),
             dns.rdata._base64ify(self.signature)
-            )
+        )
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         type_covered = dns.rdatatype.from_text(tok.get_string())
         algorithm = dns.dnssec.algorithm_from_text(tok.get_string())
         labels = tok.get_int()
@@ -114,16 +119,14 @@ class RRSIG(dns.rdata.Rdata):
                 break
             if not t.is_identifier():
                 raise dns.exception.SyntaxError
-            chunks.append(t.value)
-        b64 = ''.join(chunks)
-        signature = b64.decode('base64_codec')
+            chunks.append(t.value.encode())
+        b64 = b''.join(chunks)
+        signature = base64.b64decode(b64)
         return cls(rdclass, rdtype, type_covered, algorithm, labels,
                    original_ttl, expiration, inception, key_tag, signer,
                    signature)
 
-    from_text = classmethod(from_text)
-
-    def to_wire(self, file, compress = None, origin = None):
+    def to_wire(self, file, compress=None, origin=None):
         header = struct.pack('!HBBIIIH', self.type_covered,
                              self.algorithm, self.labels,
                              self.original_ttl, self.expiration,
@@ -132,23 +135,22 @@ class RRSIG(dns.rdata.Rdata):
         self.signer.to_wire(file, None, origin)
         file.write(self.signature)
 
-    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
-        header = struct.unpack('!HBBIIIH', wire[current : current + 18])
+    @classmethod
+    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin=None):
+        header = struct.unpack('!HBBIIIH', wire[current: current + 18])
         current += 18
         rdlen -= 18
         (signer, cused) = dns.name.from_wire(wire[: current + rdlen], current)
         current += cused
         rdlen -= cused
-        if not origin is None:
+        if origin is not None:
             signer = signer.relativize(origin)
-        signature = wire[current : current + rdlen].unwrap()
+        signature = wire[current: current + rdlen].unwrap()
         return cls(rdclass, rdtype, header[0], header[1], header[2],
                    header[3], header[4], header[5], header[6], signer,
                    signature)
 
-    from_wire = classmethod(from_wire)
-
-    def choose_relativity(self, origin = None, relativize = True):
+    def choose_relativity(self, origin=None, relativize=True):
         self.signer = self.signer.choose_relativity(origin, relativize)
 
     def _cmp(self, other):
Index: dnspython-1.12.0/dns/rdtypes/ANY/SOA.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/SOA.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/SOA.py
@@ -18,8 +18,11 @@ import struct
 import dns.exception
 import dns.rdata
 import dns.name
+from dns._compat import xcmp
+
 
 class SOA(dns.rdata.Rdata):
+
     """SOA record
 
     @ivar mname: the SOA MNAME (master name) field
@@ -58,9 +61,10 @@ class SOA(dns.rdata.Rdata):
         rname = self.rname.choose_relativity(origin, relativize)
         return '%s %s %d %d %d %d %d' % (
             mname, rname, self.serial, self.refresh, self.retry,
-            self.expire, self.minimum )
+            self.expire, self.minimum)
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         mname = tok.get_name()
         rname = tok.get_name()
         mname = mname.choose_relativity(origin, relativize)
@@ -72,24 +76,23 @@ class SOA(dns.rdata.Rdata):
         minimum = tok.get_ttl()
         tok.get_eol()
         return cls(rdclass, rdtype, mname, rname, serial, refresh, retry,
-                   expire, minimum )
+                   expire, minimum)
 
-    from_text = classmethod(from_text)
-
-    def to_wire(self, file, compress = None, origin = None):
+    def to_wire(self, file, compress=None, origin=None):
         self.mname.to_wire(file, compress, origin)
         self.rname.to_wire(file, compress, origin)
         five_ints = struct.pack('!IIIII', self.serial, self.refresh,
                                 self.retry, self.expire, self.minimum)
         file.write(five_ints)
 
-    def to_digestable(self, origin = None):
+    def to_digestable(self, origin=None):
         return self.mname.to_digestable(origin) + \
             self.rname.to_digestable(origin) + \
             struct.pack('!IIIII', self.serial, self.refresh,
                         self.retry, self.expire, self.minimum)
 
-    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
+    @classmethod
+    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin=None):
         (mname, cused) = dns.name.from_wire(wire[: current + rdlen], current)
         current += cused
         rdlen -= cused
@@ -99,29 +102,27 @@ class SOA(dns.rdata.Rdata):
         if rdlen != 20:
             raise dns.exception.FormError
         five_ints = struct.unpack('!IIIII',
-                                  wire[current : current + rdlen])
-        if not origin is None:
+                                  wire[current: current + rdlen])
+        if origin is not None:
             mname = mname.relativize(origin)
             rname = rname.relativize(origin)
         return cls(rdclass, rdtype, mname, rname,
                    five_ints[0], five_ints[1], five_ints[2], five_ints[3],
                    five_ints[4])
 
-    from_wire = classmethod(from_wire)
-
-    def choose_relativity(self, origin = None, relativize = True):
+    def choose_relativity(self, origin=None, relativize=True):
         self.mname = self.mname.choose_relativity(origin, relativize)
         self.rname = self.rname.choose_relativity(origin, relativize)
 
     def _cmp(self, other):
-        v = cmp(self.mname, other.mname)
+        v = xcmp(self.mname, other.mname)
         if v == 0:
-            v = cmp(self.rname, other.rname)
+            v = xcmp(self.rname, other.rname)
             if v == 0:
                 self_ints = struct.pack('!IIIII', self.serial, self.refresh,
                                         self.retry, self.expire, self.minimum)
                 other_ints = struct.pack('!IIIII', other.serial, other.refresh,
                                          other.retry, other.expire,
                                          other.minimum)
-                v = cmp(self_ints, other_ints)
+                v = xcmp(self_ints, other_ints)
         return v
Index: dnspython-1.12.0/dns/rdtypes/ANY/SSHFP.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/SSHFP.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/SSHFP.py
@@ -14,11 +14,15 @@
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
 import struct
+import binascii
 
 import dns.rdata
 import dns.rdatatype
+from dns._compat import xcmp
+
 
 class SSHFP(dns.rdata.Rdata):
+
     """SSHFP record
 
     @ivar algorithm: the algorithm
@@ -44,7 +48,8 @@ class SSHFP(dns.rdata.Rdata):
                              dns.rdata._hexify(self.fingerprint,
                                                chunksize=128))
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         algorithm = tok.get_uint8()
         fp_type = tok.get_uint8()
         chunks = []
@@ -54,18 +59,17 @@ class SSHFP(dns.rdata.Rdata):
                 break
             if not t.is_identifier():
                 raise dns.exception.SyntaxError
-            chunks.append(t.value)
-        fingerprint = ''.join(chunks)
-        fingerprint = fingerprint.decode('hex_codec')
+            chunks.append(t.value.encode())
+        fingerprint = b''.join(chunks)
+        fingerprint = binascii.unhexlify(fingerprint)
         return cls(rdclass, rdtype, algorithm, fp_type, fingerprint)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         header = struct.pack("!BB", self.algorithm, self.fp_type)
         file.write(header)
         file.write(self.fingerprint)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
         header = struct.unpack("!BB", wire[current : current + 2])
         current += 2
@@ -73,12 +77,10 @@ class SSHFP(dns.rdata.Rdata):
         fingerprint = wire[current : current + rdlen].unwrap()
         return cls(rdclass, rdtype, header[0], header[1], fingerprint)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
         hs = struct.pack("!BB", self.algorithm, self.fp_type)
         ho = struct.pack("!BB", other.algorithm, other.fp_type)
-        v = cmp(hs, ho)
+        v = xcmp(hs, ho)
         if v == 0:
-            v = cmp(self.fingerprint, other.fingerprint)
+            v = xcmp(self.fingerprint, other.fingerprint)
         return v
Index: dnspython-1.12.0/dns/rdtypes/ANY/TLSA.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/TLSA.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/TLSA.py
@@ -14,11 +14,15 @@
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
 import struct
+import binascii
 
 import dns.rdata
 import dns.rdatatype
+from dns._compat import xcmp
+
 
 class TLSA(dns.rdata.Rdata):
+
     """TLSA record
 
     @ivar usage: The certificate usage
@@ -46,9 +50,10 @@ class TLSA(dns.rdata.Rdata):
                                 self.selector,
                                 self.mtype,
                                 dns.rdata._hexify(self.cert,
-                                               chunksize=128))
+                                                  chunksize=128))
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         usage = tok.get_uint8()
         selector = tok.get_uint8()
         mtype = tok.get_uint8()
@@ -59,18 +64,17 @@ class TLSA(dns.rdata.Rdata):
                 break
             if not t.is_identifier():
                 raise dns.exception.SyntaxError
-            cert_chunks.append(t.value)
-        cert = ''.join(cert_chunks)
-        cert = cert.decode('hex_codec')
+            cert_chunks.append(t.value.encode())
+        cert = b''.join(cert_chunks)
+        cert = binascii.unhexlify(cert)
         return cls(rdclass, rdtype, usage, selector, mtype, cert)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         header = struct.pack("!BBB", self.usage, self.selector, self.mtype)
         file.write(header)
         file.write(self.cert)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
         header = struct.unpack("!BBB", wire[current : current + 3])
         current += 3
@@ -78,12 +82,10 @@ class TLSA(dns.rdata.Rdata):
         cert = wire[current : current + rdlen].unwrap()
         return cls(rdclass, rdtype, header[0], header[1], header[2], cert)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
         hs = struct.pack("!BBB", self.usage, self.selector, self.mtype)
         ho = struct.pack("!BBB", other.usage, other.selector, other.mtype)
-        v = cmp(hs, ho)
+        v = xcmp(hs, ho)
         if v == 0:
-            v = cmp(self.cert, other.cert)
+            v = xcmp(self.cert, other.cert)
         return v
Index: dnspython-1.12.0/dns/rdtypes/ANY/X25.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/X25.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/X25.py
@@ -13,11 +13,17 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
+import struct
+
 import dns.exception
 import dns.rdata
 import dns.tokenizer
+from dns._compat import text_type
+from dns._compat import xcmp
+
 
 class X25(dns.rdata.Rdata):
+
     """X25 record
 
     @ivar address: the PSDN address
@@ -28,27 +34,28 @@ class X25(dns.rdata.Rdata):
 
     def __init__(self, rdclass, rdtype, address):
         super(X25, self).__init__(rdclass, rdtype)
-        self.address = address
+        if isinstance(address, text_type):
+            self.address = address.encode()
+        else:
+            self.address = address
 
     def to_text(self, origin=None, relativize=True, **kw):
         return '"%s"' % dns.rdata._escapify(self.address)
 
+    @classmethod
     def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
         address = tok.get_string()
         tok.get_eol()
         return cls(rdclass, rdtype, address)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         l = len(self.address)
         assert l < 256
-        byte = chr(l)
-        file.write(byte)
+        file.write(struct.pack('!B', l))
         file.write(self.address)
 
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
-        l = ord(wire[current])
+        l = wire[current]
         current += 1
         rdlen -= 1
         if l != rdlen:
@@ -59,4 +66,4 @@ class X25(dns.rdata.Rdata):
     from_wire = classmethod(from_wire)
 
     def _cmp(self, other):
-        return cmp(self.address, other.address)
+        return xcmp(self.address, other.address)
Index: dnspython-1.12.0/dns/rdtypes/IN/A.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/IN/A.py
+++ dnspython-1.12.0/dns/rdtypes/IN/A.py
@@ -17,8 +17,11 @@ import dns.exception
 import dns.ipv4
 import dns.rdata
 import dns.tokenizer
+from dns._compat import xcmp
+
 
 class A(dns.rdata.Rdata):
+
     """A record.
 
     @ivar address: an IPv4 address
@@ -29,29 +32,27 @@ class A(dns.rdata.Rdata):
     def __init__(self, rdclass, rdtype, address):
         super(A, self).__init__(rdclass, rdtype)
         # check that it's OK
-        junk = dns.ipv4.inet_aton(address)
+        dns.ipv4.inet_aton(address)
         self.address = address
 
     def to_text(self, origin=None, relativize=True, **kw):
         return self.address
 
+    @classmethod
     def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
         address = tok.get_identifier()
         tok.get_eol()
         return cls(rdclass, rdtype, address)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         file.write(dns.ipv4.inet_aton(self.address))
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
-        address = dns.ipv4.inet_ntoa(wire[current : current + rdlen])
+        address = dns.ipv4.inet_ntoa(wire[current : current + rdlen]).decode()
         return cls(rdclass, rdtype, address)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
         sa = dns.ipv4.inet_aton(self.address)
         oa = dns.ipv4.inet_aton(other.address)
-        return cmp(sa, oa)
+        return xcmp(sa, oa)
Index: dnspython-1.12.0/dns/rdtypes/IN/AAAA.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/IN/AAAA.py
+++ dnspython-1.12.0/dns/rdtypes/IN/AAAA.py
@@ -18,7 +18,11 @@ import dns.inet
 import dns.rdata
 import dns.tokenizer
 
+from dns._compat import xcmp
+
+
 class AAAA(dns.rdata.Rdata):
+
     """AAAA record.
 
     @ivar address: an IPv6 address
@@ -35,24 +39,22 @@ class AAAA(dns.rdata.Rdata):
     def to_text(self, origin=None, relativize=True, **kw):
         return self.address
 
+    @classmethod
     def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
         address = tok.get_identifier()
         tok.get_eol()
         return cls(rdclass, rdtype, address)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         file.write(dns.inet.inet_pton(dns.inet.AF_INET6, self.address))
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
         address = dns.inet.inet_ntop(dns.inet.AF_INET6,
                                      wire[current : current + rdlen])
         return cls(rdclass, rdtype, address)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
         sa = dns.inet.inet_pton(dns.inet.AF_INET6, self.address)
         oa = dns.inet.inet_pton(dns.inet.AF_INET6, other.address)
-        return cmp(sa, oa)
+        return xcmp(sa, oa)
Index: dnspython-1.12.0/dns/rdtypes/IN/APL.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/IN/APL.py
+++ dnspython-1.12.0/dns/rdtypes/IN/APL.py
@@ -13,15 +13,20 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-import cStringIO
+from io import BytesIO
 import struct
+import binascii
 
 import dns.exception
 import dns.inet
 import dns.rdata
 import dns.tokenizer
+from dns._compat import xrange
+from dns._compat import xcmp
+
 
 class APLItem(object):
+
     """An APL list item.
 
     @ivar family: the address family (IANA address family registry)
@@ -54,7 +59,7 @@ class APLItem(object):
         elif self.family == 2:
             address = dns.inet.inet_pton(dns.inet.AF_INET6, self.address)
         else:
-            address = self.address.decode('hex_codec')
+            address = binascii.unhexlify(self.address)
         #
         # Truncate least significant zero bytes.
         #
@@ -63,7 +68,7 @@ class APLItem(object):
             if address[i] != chr(0):
                 last = i + 1
                 break
-        address = address[0 : last]
+        address = address[0: last]
         l = len(address)
         assert l < 128
         if self.negation:
@@ -72,7 +77,9 @@ class APLItem(object):
         file.write(header)
         file.write(address)
 
+
 class APL(dns.rdata.Rdata):
+
     """APL record.
 
     @ivar items: a list of APL items
@@ -88,7 +95,8 @@ class APL(dns.rdata.Rdata):
     def to_text(self, origin=None, relativize=True, **kw):
         return ' '.join(map(lambda x: str(x), self.items))
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         items = []
         while 1:
             token = tok.get().unescape()
@@ -109,20 +117,19 @@ class APL(dns.rdata.Rdata):
 
         return cls(rdclass, rdtype, items)
 
-    from_text = classmethod(from_text)
-
-    def to_wire(self, file, compress = None, origin = None):
+    def to_wire(self, file, compress=None, origin=None):
         for item in self.items:
             item.to_wire(file)
 
-    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
+    @classmethod
+    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin=None):
         items = []
         while 1:
             if rdlen == 0:
                 break
             if rdlen < 4:
                 raise dns.exception.FormError
-            header = struct.unpack('!HBB', wire[current : current + 4])
+            header = struct.unpack('!HBB', wire[current: current + 4])
             afdlen = header[2]
             if afdlen > 127:
                 negation = True
@@ -133,7 +140,7 @@ class APL(dns.rdata.Rdata):
             rdlen -= 4
             if rdlen < afdlen:
                 raise dns.exception.FormError
-            address = wire[current : current + afdlen].unwrap()
+            address = wire[current: current + afdlen].unwrap()
             l = len(address)
             if header[0] == 1:
                 if l < 4:
@@ -155,10 +162,8 @@ class APL(dns.rdata.Rdata):
             items.append(item)
         return cls(rdclass, rdtype, items)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
-        f = cStringIO.StringIO()
+        f = BytesIO()
         self.to_wire(f)
         wire1 = f.getvalue()
         f.seek(0)
@@ -167,4 +172,4 @@ class APL(dns.rdata.Rdata):
         wire2 = f.getvalue()
         f.close()
 
-        return cmp(wire1, wire2)
+        return xcmp(wire1, wire2)
Index: dnspython-1.12.0/dns/rdtypes/IN/DHCID.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/IN/DHCID.py
+++ dnspython-1.12.0/dns/rdtypes/IN/DHCID.py
@@ -13,9 +13,14 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
+import base64
+
 import dns.exception
+from dns._compat import xcmp
+
 
 class DHCID(dns.rdata.Rdata):
+
     """DHCID record
 
     @ivar data: the data (the content of the RR is opaque as far as the
@@ -32,7 +37,8 @@ class DHCID(dns.rdata.Rdata):
     def to_text(self, origin=None, relativize=True, **kw):
         return dns.rdata._base64ify(self.data)
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         chunks = []
         while 1:
             t = tok.get().unescape()
@@ -40,21 +46,18 @@ class DHCID(dns.rdata.Rdata):
                 break
             if not t.is_identifier():
                 raise dns.exception.SyntaxError
-            chunks.append(t.value)
-        b64 = ''.join(chunks)
-        data = b64.decode('base64_codec')
+            chunks.append(t.value.encode())
+        b64 = b''.join(chunks)
+        data = base64.b64decode(b64)
         return cls(rdclass, rdtype, data)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         file.write(self.data)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
         data = wire[current : current + rdlen].unwrap()
         return cls(rdclass, rdtype, data)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
-        return cmp(self.data, other.data)
+        return xcmp(self.data, other.data)
